<template>
  <b-container>
    <b-row>
      <b-col>
        <h1>FAQ</h1>
      </b-col>
    </b-row>
    <b-row>
      <b-col sm="4">
        <Sidebar>
          <Searchbar class="mb-4" @searched="onFilterChanged($event, 'searchTerm')" />
          <CategoriesSelector @categoriesChanged="onFilterChanged($event, 'categories')" />
        </Sidebar>
      </b-col>
      <b-col sm="8">
        <div v-if="faqs && faqs.length">
          <div v-for="faq in faqs" :key="faq.id">
            <Collapse
              :id="faq.id"
              class="mb-3"
              :title="faq.title"
              :content="faq.content"
              :categories="faq.categories"
            />
          </div>
        </div>
        <div v-else>
          No items found.
        </div>
      </b-col>
    </b-row>
  </b-container>
</template>

<script>
import faqQuery from '@/graphql/faq.query';
import Sidebar from '@/components/Sidebar.vue';
import CategoriesSelector from '@/components/CategoriesSelector.vue';
import Collapse from '@/components/Collapse.vue';
import Searchbar from '@/components/Searchbar.vue';

export default {
  components: {
    Sidebar,
    CategoriesSelector,
    Collapse,
    Searchbar,
  },
  data() {
    return {
      fileters: {
        searchTerm: null,
        categories: null,
      },
    };
  },
  apollo: {
    faqs: {
      query: faqQuery,
      variables() {
        return {
          searchTerm: this.fileters.searchTerm,
          categories: this.fileters.categories,
        };
      },
    },
  },
  methods: {
    onFilterChanged($event, filtername) {
      this.fileters[filtername] = $event;
      this.$apollo.queries.faqs.refetch();
    },
  },
};
</script>
